﻿using Microsoft.Practices.Unity.InterceptionExtension;
using Microsoft.Practices.Unity.ObjectBuilder;
namespace Artech.InterceptableUnity
{
    public class ExtendedInterception : Interception
    {
        public IInterceptor Interceptor
        { get; internal set; }

        public ExtendedInterception()
        {
            this.Interceptor = new TransparentProxyInterceptor();
        }

        protected override void Initialize()
        {
            this.Context.Strategies.Add(new ExtendedInstanceInterceptionStrategy(this), UnityBuildStage.Setup);
            this.Context.Strategies.Add(new ExtendedTypeInterceptionStrategy(this), UnityBuildStage.PreCreation);
            this.Context.Container.RegisterInstance<InjectionPolicy>(typeof(AttributeDrivenPolicy).AssemblyQualifiedName, new AttributeDrivenPolicy());
        }
    }
}